import ts from 'typescript';
import { IDebug } from './logger';
import { ProjectConfig } from './ProjectConfig';
declare class ResolveResult {
    private readonly self;
    private readonly id;
    private readonly options;
    private readonly getPacakgeJson;
    private readonly logger;
    protected readonly resolvedModule: ts.ResolvedModuleFull | undefined;
    protected readonly failedLookupLocations: ReadonlyArray<string>;
    readonly isInternal: boolean;
    constructor(self: string, id: string, options: ts.CompilerOptions, getPacakgeJson: () => string | undefined, resolved: ts.ResolvedModuleWithFailedLookupLocations, logger: IDebug);
    get success(): boolean;
    get isNodeModules(): boolean;
    get moduleName(): string | undefined;
    get modulePath(): string | undefined;
    get absoluteRealpath(): string | undefined;
    get absolutePathWithExtension(): string;
    get absolutePath(): string;
    get extension(): "" | ts.Extension;
    get relativeToSource(): string;
    get relativeToSourceRoot(): string;
    readPackageJson(): any;
    printWhyFailed(): void;
}
export declare class ModuleResolver extends ProjectConfig {
    private readonly resolveCache?;
    constructor(compilerOptions: ts.CompilerOptions, logger: IDebug, host?: ts.CompilerHost);
    resolve(self: string, id: string): ResolveResult;
    getPathInfo(id: string): {
        packageName: string;
        fileName: string;
    };
}
export {};
//# sourceMappingURL=ModuleResolver.d.ts.map