import ts from 'typescript';
import { IDebug } from './logger';
export declare abstract class NodeReplacer<T extends ts.Node, RT = ts.Node> {
    logger: IDebug;
    abstract readonly kinds: ReadonlyArray<ts.SyntaxKind>;
    abstract check(node: ts.Node, logger: IDebug): boolean;
    protected abstract _replace(node: T, context: ts.TransformationContext, logger: IDebug): RT | undefined | void;
    constructor();
    replace(node: T, context: ts.TransformationContext, logger: IDebug): RT | undefined | void;
}
export declare class ReplacementSet {
    protected readonly context: ts.TransformationContext;
    protected readonly logger: IDebug;
    private readonly list;
    constructor(context: ts.TransformationContext, logger: IDebug);
    execute(node: ts.Node): ts.Node | ts.Node[];
    push(replacer: NodeReplacer<ts.Node, ts.Node>): void;
    get syntaxKinds(): ts.SyntaxKind[];
}
//# sourceMappingURL=testReplace.d.ts.map